//***************************克哈RA2平衡小车***************************************//
#ifndef _controller_h_
#define _controller_h_
#include "hal_data.h"

extern int hall1count;
extern int hall2count;
extern float dis;
extern uint8_t mode;

#define AIN1_HIGH   R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_00_PIN_13, 1)
#define AIN1_LOW    R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_00_PIN_13, 0)
#define AIN2_HIGH   R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_00_PIN_14, 1)
#define AIN2_LOW    R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_00_PIN_14, 0)

#define BIN1_HIGH   R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_04_PIN_07, 1)
#define BIN1_LOW    R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_04_PIN_07, 0)
#define BIN2_HIGH   R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_02_PIN_08, 1)
#define BIN2_LOW    R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_02_PIN_08, 0)

#define STBY_HIGH    R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_01_PIN_02, 1)
#define STBY_LOW     R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_01_PIN_02, 0)


#define AMPLITUDE 7000    
#define MODE_PS2            1
#define MODE_BLUETEETH      2
#define MODE_USER           3

#define TheCarMode          2

#define remoteMode          0
#define ultraFollow         1
#define infraredTrace       2
#define ultraAvoid          3

#define UltraTurnDist       25

typedef struct 
{
    float ForwardOrBackward;
    float LeftOrRight;
    int LeftOrRightTurOut;
    float Speed;
    
    uint8_t ContorlMode;
    
}_REMOTE_Data;

typedef struct 
{
    int out;
}_OUT_Motor;


typedef struct
{
    int balance;
    int velocity;
    int turn;
    
    float bais[3];
    float exp[3];
    
    int pwm[3];
    int out[3];
    int motor[2];
    
}_OUT_CONTROL;

typedef struct
{
    float kp;
    float ki;
    float kd;
}_PID_CONTROL;

void motor_pwm_out(uint16_t pwm1,uint16_t pwm2);

void angle_controller(void);
void gyro_controller(void);
void _controller_output(void);
void _controller_perform(void);
uint8_t shut_down(float angle,float Target);    

int ctr_bal(float angle,float gyro);
int ctr_vel(int encoder_left,int encoder_right);
int ctr_turn(int turn, float gyro_z);
void _ctr_out(void);

void dir_config(int *motor1,int *motor2);


extern _OUT_Motor Motor1;
extern _OUT_CONTROL ctr;
extern _PID_CONTROL vel;
extern _PID_CONTROL bal;
extern _PID_CONTROL tur;


extern _REMOTE_Data remote;

extern int CarStepForwardOrBackward;
extern int CarStepLeftOrRight;

#endif

