//***************************克哈RA2平衡小车***************************************//
#include "hal_data.h"
#include "controller.h"
#include "oled.h"
#include "i2c_soft.h"
#include "mpu6050.h"
#include "imath.h"
#include "imu.h"



FSP_CPP_HEADER
void R_BSP_WarmStart(bsp_warm_start_event_t event);
FSP_CPP_FOOTER


bsp_io_level_t p_port_value_port_104;   //ECHO引脚
uint32_t Hightime_counter = 0;          //高电平时间
float dis =0;                           //距离
uint8_t dis_Start=0;                    //测量开始标志
uint8_t Dis=0;                          //测量距离cm

bsp_io_level_t p_port_value_port_212;//马达1 （B相）  通道1
bsp_io_level_t p_port_value_port_213;//马达1 （A相）  通道2
bsp_io_level_t p_port_value_port_408;//马达2 （A相）  通道7
bsp_io_level_t p_port_value_port_409;//马达2 （B相）  通道6

bsp_io_level_t p_port_value_port_015;   //ECHO引脚

uint8_t direction_a=0;
uint8_t direction_b=0;

int hall1count_a=0;
int hall1count_b=0;
int hall2count_a=0;
int hall2count_b=0;
int hall1count=0;
int hall2count=0;

volatile bool uart_send_complete_flag = false;
#define USART_REC_LEN       200       //定义最大接收字节数 200
char  USART_RX_BUF[USART_REC_LEN]; //接收缓冲,最大USART_REC_LEN个字节.末字节为换行符
uint16_t USART_RX_STA=0;      //接收状态标记
uint8_t mode=0;               // 0平衡模式  1跟踪模式  2避障模式
uint8_t move=0;               // 0停止  1前  2后  3左  4右 （方向控制仅在平衡模式下）
uint8_t speed=0;              // 1加5  2减5
uint16_t RxLine=0;               //接收到的数据长度


#ifdef __GNUC__                                 //串口重定向
    #define PUTCHAR_PROTOTYPE int __io_putchar(int ch)
#else
    #define PUTCHAR_PROTOTYPE int fputc(int ch, FILE *f)
#endif

PUTCHAR_PROTOTYPE
{
        R_SCI_UART_Write(&g_uart9_ctrl, (uint8_t *)&ch, 1);
        while(uart_send_complete_flag == false){}
        uart_send_complete_flag = false;
        return ch;
}
int _write(int fd,char *pBuffer,int size)
{
    for(int i=0;i<size;i++)
    {
        __io_putchar(*pBuffer++);
    }
    return size;
}
void user_uart9_callback(uart_callback_args_t * p_args)
{
    if(p_args->event == UART_EVENT_TX_COMPLETE)
    {
        uart_send_complete_flag = true;
    }
}

void user_uart_callback(uart_callback_args_t * p_args)
{
    uint8_t RxBuff;
    if(p_args->event == UART_EVENT_TX_COMPLETE)
    {
        uart_send_complete_flag = true;
    }
    if(p_args->event ==     UART_EVENT_RX_CHAR)
    {
        RxBuff = p_args->data;
        if((USART_RX_STA&0x8000)==0)//接收未完成
        {
            if(USART_RX_STA&0x4000)//接收到了0x0d
            {
                if(RxBuff!=0x0a)
                {
                    USART_RX_STA=0;//接收错误,重新开始
                    memset(USART_RX_BUF,0,sizeof(USART_RX_BUF));  //清空缓存数组
                }
                else USART_RX_STA|=0x8000;  //接收完成了
            }
            else //还没收到0X0D，继续接收来的数据
            {
                if(RxBuff==0x0d)USART_RX_STA|=0x4000;//接收到了0x0d
                else//接收数据
                {
                    USART_RX_BUF[USART_RX_STA&0X3FFF]=RxBuff ;
                    USART_RX_STA++;
                    if(USART_RX_STA>(USART_REC_LEN-1))
                    {
                        USART_RX_STA=0;//接收数据长度超过最大接收还没收到0x0d,接收数据错误,重新开始接收
                        memset(USART_RX_BUF,0,sizeof(USART_RX_BUF));  //清空缓存数组
                    }
                }
            }
        }
    }
}


void ParseBluetoothMessage(char *pInput)
{

    if(strcmp(pInput,"mode=0")==0)mode=0;//平衡模式
    if(strcmp(pInput,"mode=1")==0)mode=1;//跟踪模式
    if(strcmp(pInput,"mode=2")==0)mode=2;//避障模式
    if(strcmp(pInput,"move=0")==0)move=0;//停止
    if(strcmp(pInput,"move=1")==0)move=1;//前进
    if(strcmp(pInput,"move=2")==0)move=2;//后退
    if(strcmp(pInput,"move=3")==0)move=3;//左转
    if(strcmp(pInput,"move=3")==0)move=4;//右转
    if(strcmp(pInput,"speed=1")==0)speed=1;//加5
    if(strcmp(pInput,"speed=2")==0)speed=2;//减5
}

void SR04_OLED(void)
{
    /* 超声波测量信号 */
    dis_Start=1;
    R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_00_PIN_10, 1);
    R_BSP_SoftwareDelay (20, BSP_DELAY_UNITS_MICROSECONDS);
    R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_00_PIN_10, 0);

    /* OLED显示 */
    OLED_ShowString(0,0,"ValLeft :",12);
    if(hall1count>=0)
    {
        OLED_ShowString(82,0,"+",12);
        OLED_ShowNum(90,0,hall1count,3,12);
    }
    else
    {
        OLED_ShowString(82,0,"-",12);
        OLED_ShowNum(90,0,-(hall1count),3,12);
    }

    OLED_ShowString(0,1,"ValRight:",12);
    if(hall2count>=0)
    {
        OLED_ShowString(82,1,"+",12);
        OLED_ShowNum(90,1,hall2count,3,12);
    }
    else
    {
        OLED_ShowString(82,1,"-",12);
        OLED_ShowNum(90,1,-(hall2count),3,12);
    }

    Dis=dis;
    OLED_ShowString(0,6,"dis:",12);
    OLED_ShowNum(90,6,Dis,3,12);

    OLED_ShowString(0,4,"Mode:",12);
    OLED_ShowNum(90,4,mode,3,12);
}

void timer3_callback(timer_callback_args_t * p_args)
{

}
void SR04_callback(external_irq_callback_args_t *p_args)
{
    timer_status_t status;//获取当前计数值
    if (1 == p_args->channel)
    {
        /*读取端口电平状态，如果是低电平则发生的是下降沿，高电平则是上升沿*/
        R_IOPORT_PinRead(&g_ioport_ctrl, BSP_IO_PORT_01_PIN_04, &p_port_value_port_104);
        if(dis_Start == 1)
        {
            if(p_port_value_port_104 == BSP_IO_LEVEL_HIGH)//上升沿
            {
                R_GPT_CounterSet(&g_timer3_ctrl, 0);
                R_GPT_Start(&g_timer3_ctrl);
            }
            else
            {
                dis_Start=0;
                R_GPT_StatusGet(&g_timer3_ctrl, &status);
                Hightime_counter =status.counter;
                dis = (float)Hightime_counter*17000/48000000 ;//(高电平时间)*340*100/2 cm   高电平时间；高电平计数次数/PCLK(48M)
                R_GPT_Stop(&g_timer3_ctrl);
            }
        }
    }
}


void hall_callback(external_irq_callback_args_t *p_args)
{
       //马达1   A相上升沿检测到B相高电平为正相
       /* 判断中断通道 */
    if (2 == p_args->channel)//马达1 （A相）
    {
        R_IOPORT_PinRead(&g_ioport_ctrl, BSP_IO_PORT_02_PIN_13, &p_port_value_port_213);
        R_IOPORT_PinRead(&g_ioport_ctrl, BSP_IO_PORT_02_PIN_12, &p_port_value_port_212);
        if(p_port_value_port_213)//A相上升沿
        {
            if(p_port_value_port_212)
            {
                hall1count_a++;
            }
            else
            {
                hall1count_a--;
            }
        }
        else//A相下降沿
        {
            if(p_port_value_port_212)
            {
                hall1count_a--;
            }
            else
            {
                hall1count_a++;
            }
        }
    }
    else if (3 == p_args->channel)//马达1 （B相）
    {
        R_IOPORT_PinRead(&g_ioport_ctrl, BSP_IO_PORT_02_PIN_13, &p_port_value_port_213);
        R_IOPORT_PinRead(&g_ioport_ctrl, BSP_IO_PORT_02_PIN_12, &p_port_value_port_212);
        if(p_port_value_port_212)//B相上升沿
        {
            if(p_port_value_port_213)
            {
                hall1count_a--;
            }
            else
            {
                hall1count_a++;
            }
        }
        else//B相下降沿
        {
            if(p_port_value_port_213)
            {
                hall1count_a++;
            }
            else
            {
                hall1count_a--;
            }
        }
    }

    else if (7 == p_args->channel)//马达2 （A相）
    {
        R_IOPORT_PinRead(&g_ioport_ctrl, BSP_IO_PORT_04_PIN_08, &p_port_value_port_408);
        R_IOPORT_PinRead(&g_ioport_ctrl, BSP_IO_PORT_04_PIN_09, &p_port_value_port_409);
        if(p_port_value_port_408)//A相上升沿
        {
            if(p_port_value_port_409)
            {
                hall2count_a++;
            }
            else
            {
                hall2count_a--;
            }
        }
        else//A相下降沿
        {
            if(p_port_value_port_409)
            {
                hall2count_a--;
            }
            else
            {
                hall2count_a++;
            }
        }
    }
    else if (6 == p_args->channel)//马达2 （B相）
    {
        R_IOPORT_PinRead(&g_ioport_ctrl, BSP_IO_PORT_04_PIN_08, &p_port_value_port_408);
        R_IOPORT_PinRead(&g_ioport_ctrl, BSP_IO_PORT_04_PIN_09, &p_port_value_port_409);
        if(p_port_value_port_409)//B相上升沿
        {
            if(p_port_value_port_408)
            {
                hall2count_a--;
            }
            else
            {
                hall2count_a++;
            }
        }
        else//B相下降沿
        {
            if(p_port_value_port_408)
            {
                hall2count_a++;
            }
            else
            {
                hall2count_a--;
            }
        }
    }
}

void timer0_callback(timer_callback_args_t * p_args)
{
    /* 定时器更新事件 */
    if (TIMER_EVENT_CYCLE_END == p_args->event)
    {
        /*********************************               MPU6050              ***********************************/
        get_gyro_raw();                                                         //陀螺仪数据
        get_deg_s(&gyro_raw_f,&Mpu.deg_s);                                      //陀螺仪原始数据转为度为单位的速率
        get_rad_s(&gyro_raw_f,&Mpu.rad_s);                                      //陀螺仪原始数据转为弧度为单位的速率
        get_acc_raw();                                                          //加速度数据
        acc_iir_lpf(&acc_raw_f,&acc_att_lpf,Mpu.att_acc_factor);                //姿态解算时加速度低通滤波
        get_acc_g(&acc_att_lpf,&Mpu.acc_g);
                                                                                //姿态解算
        mahony_update(Mpu.rad_s.x,Mpu.rad_s.y,Mpu.rad_s.z,Mpu.acc_g.x,Mpu.acc_g.y,Mpu.acc_g.z);
        Matrix_ready();                                                         //姿态解算相关矩阵更新
        /********************************************************************************************************/
        /* 马达霍尔计数 */
        hall1count=hall1count_a+hall1count_b;
        hall2count=hall2count_a+hall2count_b;
        hall1count_a=0;
        hall1count_b=0;
        hall2count_a=0;
        hall2count_b=0;
        /********************************************************************************************************/
        /* 小车模式判断 */
        //(此行不能删掉,暂时不知道为什么)难倒要加一些延时？
        R_IOPORT_PinRead(&g_ioport_ctrl, BSP_IO_PORT_00_PIN_15, &p_port_value_port_015);
//        if(0==p_port_value_port_015)mode++;
//        if(mode==3)mode=0;

        ctr.pwm[0] = ctr_bal(att.rol,Mpu.deg_s.y);                        //角度直立平衡控制器
        ctr.pwm[1] = ctr_vel(-hall1count,hall2count);                     //速度控制器
        ctr.pwm[2] = ctr_turn(2400,Mpu.deg_s.z);                             //转向控制器

        ctr.out[0] = ctr.pwm[0] + ctr.pwm[1] + ctr.pwm[2];             //电机1匹配输出
        ctr.out[1] = ctr.pwm[0] + ctr.pwm[1] - ctr.pwm[2];             //电机2匹配输出
        i_limit(&(ctr.out[0]),7199);                                      //输出限幅
        i_limit(&(ctr.out[1]),7199);                                      //输出限幅

        dir_config(&(ctr.out[0]),&(ctr.out[1]));                          //根据正负设置方向

        _ctr_out();
    }
}


/*******************************************************************************************************************//**
 * main() is generated by the RA Configuration editor and is used to generate threads if an RTOS is used.  This function
 * is called by main() when no RTOS is used.
 **********************************************************************************************************************/
void hal_entry(void)
{
    /* TODO: add your own code here */
    /* 蓝牙、串口初始化 */
    R_SCI_UART_Open(&g_uart0_ctrl, &g_uart0_cfg);
    //R_SCI_UART_Open(&g_uart9_ctrl, &g_uart9_cfg);
    /* 马达PWM初始化 */
    R_GPT_Open(&g_pwm1_ctrl, &g_pwm1_cfg);
    R_GPT_Open(&g_pwm2_ctrl, &g_pwm2_cfg);
    R_GPT_Start(&g_pwm1_ctrl);
    R_GPT_Start(&g_pwm2_ctrl);
    STBY_HIGH;

    /* 编码器初始化 */
    R_ICU_ExternalIrqOpen(&g_external_irq0_ctrl, &g_external_irq0_cfg);//编码器A初始化
    R_ICU_ExternalIrqOpen(&g_external_irq1_ctrl, &g_external_irq1_cfg);
    R_ICU_ExternalIrqOpen(&g_external_irq2_ctrl, &g_external_irq2_cfg);//编码器B初始化
    R_ICU_ExternalIrqOpen(&g_external_irq3_ctrl, &g_external_irq3_cfg);
    R_ICU_ExternalIrqEnable(&g_external_irq0_ctrl); /* 允许中断 */
    R_ICU_ExternalIrqEnable(&g_external_irq1_ctrl);
    R_ICU_ExternalIrqEnable(&g_external_irq2_ctrl);
    R_ICU_ExternalIrqEnable(&g_external_irq3_ctrl);

    R_GPT_Open(&g_timer0_ctrl, &g_timer0_cfg);//定时器中断 9ms
    R_GPT_Start(&g_timer0_ctrl);

    /* 超声波初始化 */
    R_GPT_Open(&g_timer3_ctrl, &g_timer3_cfg);
    R_ICU_ExternalIrqOpen(&g_external_irq4_ctrl, &g_external_irq4_cfg);
    R_ICU_ExternalIrqEnable(&g_external_irq4_ctrl);

    OLED_Init();
    mpu6050_init();
    /* 检测mpu6050是否插上 */
      while(1)
      {
          uint8_t mpuId;
          mpuId = get_mpu_id();
          OLED_ShowString(10,2,"mpuId:",12);
          OLED_ShowNum(90,2,mpuId,4,12);
  //        printf("MPU ID :%d\r\n", mpuId);
          if(mpuId==0x68||mpuId==0x98)   //判断mpu6050的ID是否正确
          break;
          R_BSP_SoftwareDelay(50, BSP_DELAY_UNITS_MILLISECONDS);

      }
      get_iir_factor(&Mpu.att_acc_factor,0.005f,25);       //角度直立平衡控制器


    while(1)
    {
        if(USART_RX_STA&0x8000)            //接收结束标志位，这个数据可以自定义，根据实际需求，这里只做示例使用，不一定是0xff
        {
            RxLine=USART_RX_STA&0x3fff;
            ParseBluetoothMessage(USART_RX_BUF);
//            printf("length=%d\r\n",RxLine);
//            for(int i=0;i<RxLine;i++)printf("data:[%d] = 0x%x\r\n",i,USART_RX_BUF[i]);
//            printf("\r\n\r\n");//插入换行
            USART_RX_STA=0;
            memset(USART_RX_BUF,0,sizeof(USART_RX_BUF));  //清空缓存数组  ##必须加这条，否则strcmp出错##
        }

        SR04_OLED();
        R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_00_PIN_12, BSP_IO_LEVEL_LOW);
        R_BSP_SoftwareDelay(75, BSP_DELAY_UNITS_MILLISECONDS);
        SR04_OLED();
        R_BSP_SoftwareDelay(75, BSP_DELAY_UNITS_MILLISECONDS);

        SR04_OLED();
        R_IOPORT_PinWrite(&g_ioport_ctrl, BSP_IO_PORT_00_PIN_12, BSP_IO_LEVEL_HIGH);
        R_BSP_SoftwareDelay(75, BSP_DELAY_UNITS_MILLISECONDS);

        SR04_OLED();
        R_BSP_SoftwareDelay(75, BSP_DELAY_UNITS_MILLISECONDS);
    }

#if BSP_TZ_SECURE_BUILD
    /* Enter non-secure code */
    R_BSP_NonSecureEnter();
#endif
}

/*******************************************************************************************************************//**
 * This function is called at various points during the startup process.  This implementation uses the event that is
 * called right before main() to set up the pins.
 *
 * @param[in]  event    Where at in the start up process the code is currently at
 **********************************************************************************************************************/
void R_BSP_WarmStart(bsp_warm_start_event_t event)
{
    if (BSP_WARM_START_RESET == event)
    {
#if BSP_FEATURE_FLASH_LP_VERSION != 0

        /* Enable reading from data flash. */
        R_FACI_LP->DFLCTL = 1U;

        /* Would normally have to wait tDSTOP(6us) for data flash recovery. Placing the enable here, before clock and
         * C runtime initialization, should negate the need for a delay since the initialization will typically take more than 6us. */
#endif
    }

    if (BSP_WARM_START_POST_C == event)
    {
        /* C runtime environment and system clocks are setup. */

        /* Configure pins. */
        R_IOPORT_Open (&g_ioport_ctrl, g_ioport.p_cfg);
    }
}

#if BSP_TZ_SECURE_BUILD

FSP_CPP_HEADER
BSP_CMSE_NONSECURE_ENTRY void template_nonsecure_callable ();

/* Trustzone Secure Projects require at least one nonsecure callable function in order to build (Remove this if it is not required to build). */
BSP_CMSE_NONSECURE_ENTRY void template_nonsecure_callable ()
{

}
FSP_CPP_FOOTER

#endif
