//***************************克哈RA2平衡小车***************************************//
#include "i2c_soft.h"
#include "hal_data.h"

bsp_io_level_t p_port_value_port_002;

//起始信号
void IIC_Start(void)
{
    SDA_OUT();
    SCL_HIGH;
    SDA_HIGH;
    SDA_LOW;
}

//停止信号
void IIC_Stop(void)
{
    SDA_OUT();
    SCL_LOW;
    SDA_LOW;
    SCL_HIGH;
    SDA_HIGH;
}

/* 等待从机应答信号          */
/* 返回值： 0：接收应答失败  */
/*          1：接收应答成功  */
unsigned char IIC_Slave_Ack(void)
{

    SDA_OUT();
    SCL_LOW;
    SDA_HIGH;
    SDA_IN();
    SCL_HIGH;
    R_IOPORT_PinRead(&g_ioport_ctrl, BSP_IO_PORT_00_PIN_02, &p_port_value_port_002);
    if(p_port_value_port_002)
    {
        SCL_LOW;
        return 0;
    }
    SCL_LOW;
    return 1;
}

//发送一个字节
void IIC_Send_Byte(unsigned char byte)
{
    unsigned char i = 8;
    SDA_OUT();
    while (i--)
    {
        SCL_LOW;                //拉低时钟开始数据传输
        if (byte & 0x80)
            SDA_HIGH;
        else
            SDA_LOW;
        byte <<= 1;
        SCL_HIGH;
    }
    SCL_LOW;
    if(IIC_Slave_Ack()==0)
    {
        return ;
    }
}

/* 读取一个字节数据   */
/* 返回值：读取的数据 */
unsigned char IIC_Read_Byte(void)
{
    unsigned char i;
    unsigned char dat = 0;
    SDA_IN();
    for (i=0; i<8; i++)
    {
        dat <<= 1;
        SCL_HIGH;
        R_IOPORT_PinRead(&g_ioport_ctrl, BSP_IO_PORT_00_PIN_02, &p_port_value_port_002);
        dat |= p_port_value_port_002;
        SCL_LOW;
    }
    return dat;
}


/* 向寄存器写一个字节数据       */
/* SlaveAddress：从机地址       */
/* REG_Address：寄存器地址      */
/* REG_data：向寄存器写入的数据 */
void IIC_Write_One_Byte(unsigned char SlaveAddress,unsigned char REG_Address,unsigned char REG_data)
{
    IIC_Start();
    IIC_Send_Byte(SlaveAddress);
    IIC_Send_Byte(REG_Address);
    IIC_Send_Byte(REG_data);
    IIC_Stop();
}
/* 从寄存器读取一个字节数据 */
/* SlaveAddress：从机地址   */
/* REG_Address： 寄存器地址 */
/* 返回值：读取的数据       */
unsigned char IIC_Read_One_Byte(unsigned char SlaveAddress,unsigned char REG_Address)
{
    unsigned char REG_data;

    IIC_Start();
    IIC_Send_Byte(SlaveAddress);
    IIC_Send_Byte(REG_Address);
    IIC_Start();
    IIC_Send_Byte(SlaveAddress+1);
    REG_data = IIC_Read_Byte();
    IIC_Slave_Ack();
    IIC_Stop();
    return REG_data;
}
//连续读取两个字节数据
unsigned short int IIC_Read_Two_Bytes(unsigned char SlaveAddress,unsigned char REG_Address)
{
    unsigned char H, L;
    H = IIC_Read_One_Byte(SlaveAddress,REG_Address);
    L = IIC_Read_One_Byte(SlaveAddress,REG_Address+1);
    return ( ((unsigned short int)H) << 8 | L) ;
}












